let labels;
let censor_type;
let file_types;
let blur_configuration;
let bar_configuration;
let pixel_configuration;
let glitch_configuration;
let triangle_configuration;
let box_configuration;
let sticker_configuration;
let sobel_configuration;
let splatter_configuration;
let mixed_configuration;
let mixed_configuration_video;
let random_configuration;
let gif_configuration;
let reverse_mode_configuration;
let clustering_configuration;
let sticker_collections;
let lock_configuration;
let word_wall_configuration;
let config_pack = {};

let content_handler_initialized = false;

let puryfi_active = false;

browser.storage.sync.get('active').then((res) => {
    puryfi_active = res.active;
});

function initStorageData() {
    let video_handler_options = browser.storage.sync.get(['file_types', 'labels', 'censor_type',
        'bar_configuration', 'blur_configuration', 'pixel_configuration', 'gif_configuration', 'glitch_configuration',
        'triangle_configuration', 'box_configuration', 'sticker_configuration', 'sobel_configuration', 'splatter_configuration',
        'mixed_configuration', 'random_configuration',
        'reverse_mode_configuration', 'clustering_configuration', 'lock_configuration', 'word_wall_configuration']);
    video_handler_options.then((res) => {
        labels = res.labels;
        censor_type = res.censor_type;
        file_types = res.file_types;
        blur_configuration = res.blur_configuration;
        bar_configuration = res.bar_configuration;
        pixel_configuration = res.pixel_configuration;
        glitch_configuration = res.glitch_configuration;
        triangle_configuration = res.triangle_configuration;
        box_configuration = res.box_configuration;
        sticker_configuration = res.sticker_configuration;
        mixed_configuration = res.mixed_configuration;
        mixed_configuration_video = mixed_configuration;
        random_configuration = res.random_configuration;
        gif_configuration = res.gif_configuration;
        reverse_mode_configuration = res.reverse_mode_configuration;
        clustering_configuration = res.clustering_configuration;
        sobel_configuration = res.sobel_configuration;
        splatter_configuration = res.splatter_configuration;
        word_wall_configuration = res.word_wall_configuration;
        lock_configuration = res.lock_configuration;

    });
    let local_request = browser.storage.local.get(['sticker_collections']);
    local_request.then((res) => {
        if (res.sticker_collections != null) {
            sticker_collections = cloneInto(
                res.sticker_collections,
                window,
                {cloneFunctions: true});
            cacheStickerCollections(sticker_collections, sticker_configuration);
        }
    });
    let promises = [
        video_handler_options,
        local_request,
    ];
    Promise.all(promises)
        .then((values) => {
            pack_config();
        })
}

function handleMessage(request, sender, sendResponse) {
    // Check if you are in an iframe
    /*
    if(window.self !== window.top){
        return;
    }
    */

    if(request.update_options){
        let video_handler_options = browser.storage.sync.get(['file_types','labels','censor_type',
            'bar_configuration','blur_configuration','pixel_configuration','gif_configuration',
            'glitch_configuration','triangle_configuration','box_configuration','sticker_configuration','sobel_configuration',
            'splatter_configuration', 'mixed_configuration', 'random_configuration',
            'reverse_mode_configuration','word_wall_configuration','clustering_configuration','lock_configuration']);
        video_handler_options.then((res) => {
            labels = res.labels;
            censor_type = res.censor_type;
            file_types = res.file_types;
            blur_configuration  = res.blur_configuration;
            bar_configuration   = res.bar_configuration;
            pixel_configuration = res.pixel_configuration;
            glitch_configuration = res.glitch_configuration;
            triangle_configuration = res.triangle_configuration;
            box_configuration = res.box_configuration;
            sticker_configuration = res.sticker_configuration;
            gif_configuration 	= res.gif_configuration;
            reverse_mode_configuration = res.reverse_mode_configuration;
            clustering_configuration = res.clustering_configuration;
            sobel_configuration = res.sobel_configuration;
            splatter_configuration = res.splatter_configuration;
            mixed_configuration = res.mixed_configuration;
            mixed_configuration_video = mixed_configuration;
            random_configuration = res.random_configuration;
            lock_configuration = res.lock_configuration;
            word_wall_configuration = res.word_wall_configuration;
            pack_config();
        });
    }
    if(request.video){
        puryfiVideo(request.single_tab? null : request.srcUrl);
        return
    }
    if(request.local_file && request.type){
        censorLocalFile(request.reload, request.type);
        return;
    }
    let timestamp = new Date().getTime();
    let queryString = "?t=" + timestamp;
    let newurl = request.reload + queryString
    $('img').each(function(i, obj) {
        if(obj.src === request.reload){
            sendResponse({add_context_request: newurl,
                add_context_request_original_url: request.reload
            });
            obj.src = newurl;
        }
    });
    $('source').each(function(i, obj) {
        if(obj.srcset === request.reload){
            sendResponse({add_context_request: newurl,
                          add_context_request_original_url: request.reload
            });
            obj.srcset = newurl;
        }
    });
}
browser.runtime.onMessage.addListener(handleMessage);

function pack_config(){
    config_pack = {
        bar_configuration: bar_configuration,
        pixel_configuration: pixel_configuration,
        blur_configuration: blur_configuration,
        glitch_configuration: glitch_configuration,
        triangle_configuration: triangle_configuration,
        box_configuration: box_configuration,
        sticker_configuration: sticker_configuration,
        sobel_configuration: sobel_configuration,
        splatter_configuration: splatter_configuration,
        mixed_configuration: mixed_configuration_video,
        random_configuration: random_configuration,
        reverse_mode_configuration: reverse_mode_configuration,
        sticker_collections: sticker_collections,
        lock_configuration: lock_configuration,
        word_wall_configuration: word_wall_configuration,
        clustering_configuration: clustering_configuration,
    };
}