
function restoreFiletypes() {
	let file_types = browser.storage.sync.get(['file_types', 'gif_configuration']);
	file_types.then((res) => {
		$('.filetypeToggle').each(function(i, obj) {
			if(res.file_types.includes($(this).attr('label'))) {
				$(this).attr('check', true);
			} else {
				$(this).removeAttr('check');
			}
		});
        
        if (res.gif_configuration._thumbnails) {
            $('.gif-thumb').attr('check', true);
            $('.gif-frames').removeAttr('check');
        } else {
            $('.gif-thumb').removeAttr('check');
            $('.gif-frames').attr('check', true);
        }
	});
}

function restoreFileOptions(){
    $('#file-types-selector-png').click();
}

$('io-toggle.filetypeToggle').on('click',function(e){
    let file_types = browser.storage.sync.get(['file_types','gif_configuration','lock_configuration']);
    file_types.then((res) => {
        if(res.lock_configuration.enabled){
            return;
        }
        let file_typeslist = res.file_types || [];
        if($(this).attr('check')){
            if(file_typeslist.indexOf($(this).attr('label')) === -1){
                file_typeslist.push($(this).attr('label'))
            }
        }else{
            if(file_typeslist.indexOf($(this).attr('label')) !== -1){
                file_typeslist = removeItemAll(file_typeslist, $(this).attr('label'));
            }
        }

		if($(this).hasClass('gif-thumb') && $(this).attr('check')) {
			$('.gif-frames').removeAttr('check');
			res.gif_configuration._thumbnails = true;
		} else if($(this).hasClass('gif-frames') && $(this).attr('check')) {
			$('.gif-thumb').removeAttr('check');
			res.gif_configuration._thumbnails = false;
        }
        browser.storage.sync.set({
            file_types: file_typeslist,
            gif_configuration: res.gif_configuration,
        }).then(function(){
            updateOptionsContentScript();
        });
    });
});

$('.filetype-item-flex *').on('click', function(e) {
    if (e.target.closest('.filetype-toggle-flex *')) return;

    let file_conf_sync = browser.storage.sync.get(['gif_configuration', 'png_configuration', 'jpg_configuration', 'bmp_configuration', 'webp_configuration', 'avif_configuration',]);
    file_conf_sync.then((res) => {
        let $item_flex = $(this).closest('.filetype-item-flex');
        let ft = $item_flex.attr('label');

        if(ft){
            $('.file-types-selector').removeClass('selected');
            $('.filetype-toggle-flex').removeClass('selected');
            $('.filetype-toggle-label-flex').removeClass('selected');
            $item_flex.find('.file-types-selector').addClass('selected');
            $item_flex.find('.filetype-toggle-flex').addClass('selected');
            $item_flex.find('.filetype-toggle-label-flex').addClass('selected');
            $('#file-min-width').val(res[ft + '_configuration']._width_min);
            $('#file-min-height').val(res[ft + '_configuration']._height_min);
            $('#file-max-height').val(res[ft + '_configuration']._height_max);
            $('#file-max-width').val(res[ft + '_configuration']._width_max);
            if (ft === 'gif') {
                $('#content_filetypes_gif').show();
                $('#content_filetypes_images').hide();
                $('#gif-max-frames').val(res.gif_configuration._frame_count_max);
                $('#gif-fallback-to-thumbnail').prop("checked", res.gif_configuration._thumbnail_fallback);
                $('#gif-memory-mode').val(res.gif_configuration._memory_method);
                $('#gif_ai_frame_skipping').val(res.gif_configuration._ai_frame_skipping);
                $('#gif_detection_extending').val(res.gif_configuration._detection_extending);
                $('#gif_detection_similarity_threshold').val(res.gif_configuration._detection_similarity_threshold * 100);

                $('#file-gif-min-size').val(res[ft + '_configuration']._filesize_min / 1000);
                $('#file-gif-max-size').val(res[ft + '_configuration']._filesize_max / 1000);
            } else {
                $('#content_filetypes_gif').hide();
                $('#content_filetypes_images').show();
                $('#file-min-size').val(res[ft + '_configuration']._filesize_min / 1000);
                $('#file-max-size').val(res[ft + '_configuration']._filesize_max / 1000);
            }
            $('.file-output-type').prop("checked", false);
            switch (res[ft + '_configuration']._file_output_type) {
                case 'image/jpeg':
                    $('#file-output-type-jpg').prop("checked", true);
                    break;
                case 'image/png':
                    $('#file-output-type-png').prop("checked", true);
                    break;
                case 'image/bmp':
                    $('#file-output-type-bmp').prop("checked", true);
                    break;
                case 'image/webp':
                    $('#file-output-type-webp').prop("checked", true);
                    break;
                case 'image/avif':
                    $('#file-output-type-avif').prop("checked", true);
                    break;
                default:
                    if ($('#file-output-type-' + ft).length) {
                        $('#file-output-type-' + ft).prop("checked", true);
                    } else {
                        $('#file-output-type-png').prop("checked", true);
                    }
            }
        }
    });
});
/*
$('.save-file-config').on('change',function(e){
    saveFileConfig();
});
*/
function saveFileConfig() {
    let file_conf_sync = browser.storage.sync.get(['gif_configuration', 'png_configuration', 'jpg_configuration', 'bmp_configuration', 'webp_configuration', 'avif_configuration',]);
    file_conf_sync.then((res) => {
        let ft = $('.file-types-selector.selected').attr('file_type');
        if(ft === 'gif'){
            res[ft + '_configuration']._frame_count_max = parseInt($('#gif-max-frames').val());
            res[ft + '_configuration']._thumbnail_fallback = $('#gif-fallback-to-thumbnail').is(':checked');
            res[ft + '_configuration']._memory_method = parseInt($('#gif-memory-mode').val());
            res[ft + '_configuration']._filesize_min = parseInt($('#file-gif-min-size').val()) * 1000;
            res[ft + '_configuration']._filesize_max =  parseInt($('#file-gif-max-size').val()) * 1000;
            res[ft + '_configuration']._ai_frame_skipping = parseInt($('#gif_ai_frame_skipping').val());
            res[ft + '_configuration']._detection_extending = parseInt($('#gif_detection_extending').val());
            res[ft + '_configuration']._detection_similarity_threshold = parseInt($('#gif_detection_similarity_threshold').val()) / 100;
            browser.storage.sync.set({
                gif_configuration: res.gif_configuration,
            }).then(() => {
                updateOptionsContentScript();
            });
        }else if(res[ft+'_configuration']){
            res[ft + '_configuration']._filesize_min =  parseInt($('#file-min-size').val()) * 1000;
            res[ft + '_configuration']._filesize_max =  parseInt($('#file-max-size').val()) * 1000;
            res[ft + '_configuration']._width_min =  parseInt($('#file-min-width').val());
            res[ft + '_configuration']._height_min =  parseInt($('#file-min-height').val());
            res[ft + '_configuration']._height_max =  parseInt($('#file-max-height').val());
            res[ft + '_configuration']._width_max =  parseInt($('#file-max-width').val());
            res[ft + '_configuration']._file_output_type = 'image/'+$('input[name="file-output-type"]:checked').attr('file_type').replace("jpg", 'jpeg');
            browser.storage.sync.set({
                png_configuration: res.png_configuration,
                jpg_configuration: res.jpg_configuration,
                bmp_configuration: res.bmp_configuration,
                webp_configuration: res.webp_configuration,
                avif_configuration: res.avif_configuration,
            }).then(() => {
                updateOptionsContentScript();
            });
        }

    });
}
