function restoreIcons() {
    let icon_mode = browser.storage.sync.get('icon_configuration');
    icon_mode.then((res) => {
        if(res.icon_configuration != null && !res.icon_configuration.save_mode) {
            $('.icon-public').addClass('icon-nude').removeClass('icon-public');
            $('.icon-nudityToggle').removeAttr('check');
        }else{
            $('.icon-nudityToggle').attr('check', true);
        }
    });
}

$('.iconButton').click(function(){
    let icon_configuration = browser.storage.sync.get('icon_configuration');
    icon_configuration.then((res) => {
        let r = res.icon_configuration;
        if(this.value === 'classic'){
            r = {
                "16": '/icons/icon_16.png',
                "32": '/icons/icon_32.png',
                "64": '/icons/icon_64.png',
                "save_mode": res.icon_configuration.save_mode,
            };
        }else if(this.value === 'minimalistic'){
            r = {
                "16": '/icons/icon_16_minimalistic.png',
                "32": '/icons/icon_32_minimalistic.png',
                "64": '/icons/icon_64_minimalistic.png',
                "save_mode": res.icon_configuration.save_mode,
            };
        }
        else if(this.value === 'eye'){
            r = {
                "16": '/icons/icon_16_eye.png',
                "32": '/icons/icon_32_eye.png',
                "64": '/icons/icon_64_eye.png',
                "save_mode": res.icon_configuration.save_mode,
            };
        }
        browser.storage.sync.set({
            icon_configuration: r
        }).then(function(){
            updateOptionsContentScript();
        });
    });
});

$('io-toggle.icon-nudityToggle').click(function(e) {
    let conf = browser.storage.sync.get(['icon_configuration']);
    conf.then((res) => {
        res.icon_configuration.save_mode = $(this).attr('check') ? true : false;
        if(!res.icon_configuration.save_mode){
            if (confirm("Are you sure?")) {
                if (confirm("But are you really sure?")) {
                    alert("Hmmm... ok then")
                    $('.icon-public').addClass('icon-nude').removeClass('icon-public');
                } else {
                    $('.icon-nudityToggle').attr('check', true);
                    return;
                }
            } else {
                $('.icon-nudityToggle').attr('check', true);
                return;
            }
        }else{
            $('.icon-nude').addClass('icon-public').removeClass('icon-nude');
        }
        browser.storage.sync.set({
            icon_configuration: res.icon_configuration
        }).then(function(){
            updateOptionsContentScript();
        });
    });
});
