$( "#sticker_collections" ).change(function() {
    $('#sticker_collection_delete').prop('disabled', true);
    $( "#sticker_collection_disable" ).prop( "disabled", true);
    let f = $( "#sticker_collections option:selected" ).first();
    if(f && sticker_collections){
        let found = sticker_collections.find((o) => {
            return o['_name'] === f.attr('name');
        })
        if(found) {
            $( "#sticker_collection_disable" ).html(found._enabled? 'Disable' : 'Enable');
            $( "#sticker_collection_disable" ).prop( "disabled", false );
            $('#sticker_collection_add_sticker').prop('disabled', false);
            if(!found._locked){
                $('#sticker_collection_delete').prop('disabled', false);
            }
            let $display = $('.sticker-collection-display');
            let $item_template = $display.find('#sticker_collection_item_template');
            $display.find('.sticker-collection-item').not($item_template).remove();
            found._stickers.forEach(function (sticker, idx, array) {
                let $new_item = $item_template.clone({deepWithDataAndEvents: true});
                $new_item.attr('id', '');
                $new_item.attr('name', sticker.name);
                $new_item.find('.sticker-collection-image img').attr('src', sticker.url);
                $new_item.find('.sticker-collection-label').html(sticker.name);
                $display.append($new_item);
            });
        }
    }
}).trigger( "change" );

function populateAddStickerModal(collection, sticker_index) {
    let sticker = collection._stickers[sticker_index];
    if(sticker.locked){
        $( "#sticker_collection_add_delete" ).hide();
    }else{
        $( "#sticker_collection_add_delete" ).show();
    }
    $('#sticker_collection_add_name').val(sticker.name);
    updateInputField($('#sticker_collection_add_scale'), sticker.scale * 100);
    updateInputField($('#sticker_collection_add_chance'), sticker.chance);
    $('#sticker_collection_add_group').val(sticker.groups.join(';'));
    $('.sticker_collection_add_label').prop( "checked", false );
    sticker.klasses.forEach(function(klass){
        $('.sticker_collection_add_label[label="'+klass.key+'"]').prop( "checked", true );
    });
    $('#sticker_collection_add_preview_image img').attr("src", sticker.url);
    let prev_sticker_index = sticker_index - 1;
    if (prev_sticker_index < 0) prev_sticker_index = collection._stickers.length - 1;
    $('#sticker_collection_add_preview_prev_image img').attr("src", collection._stickers[prev_sticker_index].url);
    let next_sticker_index = sticker_index + 1;
    if (collection._stickers.length <= next_sticker_index) next_sticker_index = 0;
    $('#sticker_collection_add_preview_next_image img').attr("src", collection._stickers[next_sticker_index].url);
    $('#sticker_collection_add_sticker_file_input').val(null);
    $('#sticker_collection_add_sticker_modal').show();
}

$('#sticker_collection_add_preview_prev_image').click(function() {
    stickerCollectionAddSave();
    let $selected_collection = $( "#sticker_collections option:selected" ).first();
    let collection = sticker_collections.find((o) => {
        return o['_name'] === $selected_collection.attr('name');
    });
    if (collection) {
        let sticker_name = $('#sticker_collection_add_name').val();
        let sticker_index = collection._stickers.findIndex((o) => {
            return o['name'] === sticker_name;
        }) - 1;
        if (sticker_index < 0) sticker_index = collection._stickers.length - 1;
        populateAddStickerModal(collection, sticker_index);
    }
});

$('#sticker_collection_add_preview_next_image').click(function() {
    stickerCollectionAddSave();
    let $selected_collection = $( "#sticker_collections option:selected" ).first();
    let collection = sticker_collections.find((o) => {
        return o['_name'] === $selected_collection.attr('name');
    });
    if (collection) {
        let sticker_name = $('#sticker_collection_add_name').val();
        let sticker_index = collection._stickers.findIndex((o) => {
            return o['name'] === sticker_name;
        }) + 1;
        if (collection._stickers.length <= sticker_index) sticker_index = 0;
        populateAddStickerModal(collection, sticker_index);
    }
});

$('.sticker-collection-display').on('click', '.sticker-collection-item', function(){
    $("#sticker_collection_add_select_file").hide();
    $("#sticker_collection_add_cancel").hide();
    $("#sticker_collection_add_name").prop( "disabled", true );
    let $selected_collection = $( "#sticker_collections option:selected" ).first();
    let collection = sticker_collections.find((o) => {
        return o['_name'] === $selected_collection.attr('name');
    });
    
    if(collection){
        $("#sticker_collection_add_preview_prev_image").css('visibility', 'visible');
        $("#sticker_collection_add_preview_next_image").css('visibility', 'visible');
        let sticker_name = $(this).attr('name');
        let sticker_index = collection._stickers.findIndex((o) => {
            return o['name'] === sticker_name;
        });
        populateAddStickerModal(collection, sticker_index);
    }
});

$('#sticker_collection_export').click(function(){
    let f = $( "#sticker_collections option:selected" ).first();
    if(f && sticker_collections){
        let found = sticker_collections.find((o) => {
            return o['_name'] === f.attr('name');
        })
        if(found){
            found._stickers.forEach(function (sticker, idx, array) {
                if(sticker.file){
                    sticker.file = null;
                }
            });
            objToJSON(found._name+".pstp", found);
        }
    }
});

$('#sticker_collection_delete').click(function(){
    let f = $( "#sticker_collections option:selected" ).first();
    if(f && sticker_collections){
        let found = sticker_collections.find((o) => {
            return o['_name'] === f.attr('name');
        })
        if(found){
            if(!found._locked){
                removeItemOnce(sticker_collections, found);
                browser.storage.local.set({
                    sticker_collections: sticker_collections,
                }).then(function(){
                    $('#sticker_collection').empty();
                    $( "#sticker_collections" ).trigger( "change" );
                    updateOptionsContentScript(true);
                    restoreCensorConfigs();
                });
            }else{
                alert('Cannot remove default collections');
            }
        }
    }
});


$('#sticker_collection_create_add').click(function(){
    let name = $('#sticker_collection_create_name').val();
    // TODO: me no likey this
    name = name.toLowerCase();
    $( "#sticker_collection_add_select_file" ).show();
    $( "#sticker_collection_add_name" ).prop( "disabled", false );
    if(!name.length) {
        window.alert("Name must not be empty!");
        return;
    }

    if (name.indexOf(';') !== -1) {
        window.alert("Name must not contain semicolons!");
        return;
    }

    if (sticker_collections){
        let found = sticker_collections.find((o) => {
            return o['_name'] === name;
        });
        if(!found){
            let sticker_request = browser.storage.local.get(['sticker_collections']);
            sticker_request.then((res) => {
                let collection = new StickerCollection(name,[], true, false);
                res.sticker_collections.push(collection);
                sticker_collections = res.sticker_collections;
                $('#sticker_collections').empty();
                browser.storage.local.set({
                    sticker_collections: res.sticker_collections,
                }).then(function(){
                    $( "#sticker_collections" ).trigger( "change" );
                    updateOptionsContentScript(true);
                });
                res.sticker_collections.forEach(function(collection, key){
                    $('#sticker_collections').append($('<option>', {
                        value: key,
                        text: capitalizeFirstLetter(collection._name),
                        name: collection._name,
                        class: ' '+(collection._enabled? 'sticker_collection_enabled': 'sticker_collection_disabled')+
                               ' '+(collection._locked? 'sticker_collection_locked': ''),
                    }));
                });
            });
            $('#sticker_collection_create_name').val("");
        }else{
            window.alert("Name must be unique!");
        }
    }
});

$('#invert_selection').click(function() {
    $('.sticker_collection_add_label').each(function() {
        $(this).prop('checked', !$(this).prop('checked'));
    });
});

$('#select_all').click(function() {
    $('.sticker_collection_add_label').prop('checked', true);
});

$('#select_none').click(function() {
    $('.sticker_collection_add_label').prop('checked', false);
});

$('#sticker_collection_add_sticker').click(function(){
    $("#sticker_collection_add_select_file").show();
    $(".sticker_collection_add_label").prop('checked', true);
    $("#sticker_collection_add_name").prop("disabled", false);
    $("#sticker_collection_add_name").val("");
    $("#sticker_collection_add_group").val("");
    $("#sticker_collection_add_scale").val(100);
    $("#sticker_collection_add_chance").val(1);
    $("#sticker_collection_add_sticker_file_input").val(null);
    $("#sticker_collection_add_preview_image img").attr("src",'');

    $("#sticker_collection_add_delete").hide();
    $("#sticker_collection_add_cancel").show();

    $("#sticker_collection_add_sticker_modal").show();
    $("#sticker_collection_add_preview_prev_image").css('visibility', 'hidden');
    $("#sticker_collection_add_preview_next_image").css('visibility', 'hidden');
});

$( "#sticker_collection_add_select_file" ).click(function(){
    $('#sticker_collection_add_sticker_file_input').trigger('click');
});

$('#sticker_collection_add_sticker_file_input').on("change", function() {
    let files = $( "#sticker_collection_add_sticker_file_input" ).prop('files');
    if (files && files[0]) {
        $('#sticker_collection_add_name').val(files[0].name.replace(/\.[^/.]+$/, ""));
        let file = files[0];
        let reader = new FileReader();
        reader.onload = function (e) {
            $( "#sticker_collection_add_preview_image img" ).attr("src",e.target.result);
        }
        reader.readAsDataURL(file);
    }
});

function stickerCollectionAddSave() {
    let file = $( "#sticker_collection_add_sticker_file_input" ).prop('files')[0];
    let collection = $( "#sticker_collections option:selected" ).first();
    if (file) {
        if(collection && sticker_collections){
            let found = sticker_collections.find((o) => {
                return o['_name'] === collection.attr('name');
            })
            if(found){
                let sticker_name = $('#sticker_collection_add_name').val();
                sticker_name = sticker_name.toLowerCase();
                if(!sticker_name.length) {
                    window.alert("Name must not be empty!");
                    return false;
                }

                let found_sticker = found._stickers.find((o) => {
                    return o['name'] === sticker_name;
                });

                if(found_sticker){
                    window.alert("Name must be unique within the collection!");
                    return false;
                }

                let imageSrc = URL.createObjectURL(file);
                let imageData = new Image();
                imageData.onload = function () {
                    const canvas = document.createElement('canvas');
                    canvas.width = imageData.width;
                    canvas.height = imageData.height;
                    let ctx = canvas.getContext("2d");
                    ctx.drawImage(imageData, 0, 0);
                    //let data = ctx.getImageData(0, 0, canvas.width, canvas.height);
                    let dataurl = canvas.toDataURL("image/png");
                    let allowed_klasses = [];
                    Object.keys(klasses).forEach(e =>
                        {
                            let checked = $( ".sticker_collection_add_label[label='"+klasses[e].key+"']" ).is(':checked');
                            if(checked){
                                allowed_klasses.push(klasses[e]);
                            }
                        }
                    );
                    let sticker = {
                        name: sticker_name,
                        //file: data.data,
                        file: null,
                        url: dataurl,
                        width: canvas.width,
                        height: canvas.height,
                        klasses: allowed_klasses,
                        scale: Math.max(0.1,parseFloat($('#sticker_collection_add_scale').val()) / 100),
                        chance: Math.max(0,parseFloat($('#sticker_collection_add_chance').val())),
                        groups: $('#sticker_collection_add_group').val().split(';'),
                    };
                    found._stickers.push(sticker);
                    browser.storage.local.set({
                        sticker_collections: sticker_collections,
                    }).then(function(){
                        $( "#sticker_collections" ).trigger( "change" );
                        updateOptionsContentScript(true);
                    });
                }
                imageData.src = imageSrc;
            }
        }
    } else {
        let found = sticker_collections.find((o) => {
            return o['_name'] === collection.attr('name');
        })
        if(found) {
            let sticker_name = $('#sticker_collection_add_name').val();
            sticker_name = sticker_name.toLowerCase();
            if (!sticker_name) {
                window.alert("Invalid sticker name.");
                return false;
            }
            let found_sticker = found._stickers.find((o) => {
                return o['name'] === sticker_name;
            });
            if (found_sticker) {
                found_sticker.scale = Math.max(0.1,parseFloat($('#sticker_collection_add_scale').val()) / 100);
                found_sticker.chance = Math.max(0,parseFloat($('#sticker_collection_add_chance').val()));
                found_sticker.groups = $('#sticker_collection_add_group').val().split(';');
                let allowed_klasses = [];
                Object.keys(klasses).forEach(e =>
                    {
                        let checked = $( ".sticker_collection_add_label[label='"+klasses[e].key+"']" ).is(':checked');
                        if(checked){
                            allowed_klasses.push(klasses[e]);
                        }
                    }
                );
                found_sticker.klasses = allowed_klasses;
                browser.storage.local.set({
                    sticker_collections: sticker_collections,
                }).then(function(){
                    $( "#sticker_collections" ).trigger( "change" );
                    updateOptionsContentScript(true);
                });
            }
        }
    }
    return true;
}

$('#sticker_collection_add_sticker_modal_close').click(function() {
    if (stickerCollectionAddSave()) {
        $( "#sticker_collection_add_sticker_modal" ).hide();
    }
});

$( "#sticker_collection_add_delete" ).click(function(){
    $( "#sticker_collection_add_sticker_modal" ).hide();
    let f = $( "#sticker_collections option:selected" ).first();
    if(f && sticker_collections) {
            let found = sticker_collections.find((o) => {
                return o['_name'] === f.attr('name');
            })
            if (found) {
                let sticker_name = $('#sticker_collection_add_name').val();
                sticker_name = sticker_name.toLowerCase();
                if (!sticker_name) {
                    window.alert("Invalid sticker name.");
                    return;
                }
                let found_sticker = found._stickers.find((o) => {
                    return o['name'] === sticker_name;
                });
                if (found_sticker) {
                    removeItemOnce(found._stickers,found_sticker);
                    browser.storage.local.set({
                        sticker_collections: sticker_collections,
                    }).then(function(){
                        $( "#sticker_collection_add_sticker_modal" ).hide();
                        $( "#sticker_collections" ).trigger( "change" );
                        updateOptionsContentScript(true);
                    });
                }

            }
    }
});

$('#sticker_collection_add_cancel').click(function(){
    $( "#sticker_collection_add_sticker_modal" ).hide();
});

$( "#sticker_add_toggle_labels" ).click(function() {
    $('.sticker_collection_add_label').each(function () {
        $(this).prop( "checked", !$(this).prop( "checked"));
    });
});

$( "#sticker_draw_mode" ).change(function() {
    if($(this).val() == 2){
        $( "#sticker_groups" ).show();
    }else{
        $( "#sticker_groups" ).hide();
    }
});

$( "#sticker_collection_import" ).click(function() {
    $('#sticker_collection_import_file_input').trigger('click');
});

$('#sticker_collection_import_file_input').on("change", function() {
    let files = $( this ).prop('files');
    if (files && files[0]) {
        let reader = new FileReader();
        reader.onload = function(event) {
            let jsonObj = JSON.parse(event.target.result);
            if( '_enabled' in jsonObj &&
                '_locked' in jsonObj && jsonObj._locked == false &&
                '_name' in jsonObj && jsonObj._name.length > 0 &&
                '_stickers' in jsonObj
            ){
                let found = sticker_collections.find((o) => {
                    return o['_name'] === jsonObj._name;
                });
                if(found){
                    alert('A collection with that name already exists.');
                    return;
                }
                let promises = [];
                jsonObj._stickers.forEach(function (sticker, idx, array) {
                    let p = new Promise((resolve, reject) => {
                        // Legacy Support
                        if(sticker.file != null) {
                            if (!sticker.url) {
                                sticker.url = sticker.file;
                            }
                        }
                        // Legacy Support End
                        if( 'name' in sticker && sticker.name.length > 0 &&
                            'file' in sticker &&
                            'klasses' in sticker &&
                            'scale' in sticker &&
                            'chance' in sticker &&
                            'groups' in sticker
                        ){
                            let new_sticker = {
                                name: sticker.name,
                                //file: sticker.file,
                                file: null,
                                url: sticker.url,
                                width: sticker.width,
                                height: sticker.height,
                                klasses: sticker.klasses,
                                scale: sticker.scale,
                                locked: false,
                                chance: sticker.chance,
                                groups: sticker.groups,
                            };

                            if(sticker.url != null) {
                                let imageData = new Image();
                                imageData.onload = function () {
                                    const canvas = document.createElement('canvas');
                                    canvas.width = imageData.width;
                                    canvas.height = imageData.height;
                                    if (canvas.width <= 0 || canvas.height <= 0) {
                                        reject();
                                    }
                                    let ctx = canvas.getContext("2d");
                                    ctx.drawImage(imageData, 0, 0);
                                    jsonObj._stickers[idx] = new_sticker;
                                    resolve();
                                }
                                imageData.src = sticker.url;

                            }
                        }else{
                            reject("Sticker "+sticker.name+" corrupted");
                        }

                    });
                    promises.push(p);
                });
                Promise.all(promises).then((values) => {
                    sticker_collections.push(jsonObj);
                    browser.storage.local.set({
                        sticker_collections: sticker_collections,
                    }).then(function(){
                        $( "#sticker_collections" ).trigger( "change" );
                        updateOptionsContentScript(true);
                        restoreCensorConfigs();
                    });
                }).catch(function(err) {
                    alert(err);
                });;

            }else{
                log('Corrupted Collection','_enabled' in jsonObj,'_locked' in jsonObj && jsonObj._locked == false, '_name' in jsonObj && jsonObj._name.length > 0,'_stickers' in jsonObj);
                alert('Corrupted Collection');
            }

        }
        reader.readAsText(files[0]);
    }
});

$('#sticker_collection_reset_all').click(function() {
    if (window.confirm("Warning: This will delete all non default stickers and reset all default stickers.")) {
        let clearStorage = browser.storage.local.remove('sticker_collections');
        clearStorage.then(e => {
            reloadStickers();
            window.location.reload();
        });
    }
});

function reloadStickers(){
    return browser.runtime.sendMessage({
        reset_stickers: true
    });
}