$(function () {
   $(document).tooltip({
      track: true,
      items: "*[tooltip]",
      content: function () {
         return getToolTipText($(this).attr("tooltip"));
      },
      position: {
         my: "left+1 top+1",
         at: "right bottom",
      },
      show: {
         effect: "fadeIn",
         duration: 100,
      },
      hide: {
         duration: 0,
      },
   });
   $(".copy-tooltip").tooltip({
      //track: true,
      items: "*[tooltip]",
      content: function () {
         return getToolTipText($(this).attr("tooltip"));
      },
      position: {
         my: "center bottom-20",
         at: "center top",
      },
      show: {
         effect: "fadeIn",
         duration: 100,
      },
      hide: {
         duration: 0,
      },
   });
});

function getToolTipText(tooltip) {
   switch (tooltip) {
      case "bar-type":
         return (
            "<span style='font-weight:bold;'>[Paint]:</span> Paint the effect are with the given color." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Erase]:</span> Erase the effect area at the given opacity." +
            "<div class='tooltip-paragraph-break'></div>" +
            "<span style='color: var(--main-accent-color);font-weight:bold;'>NOTE:</span> Erasing might not work as expected on output file types which don't support transparency, such as JPEG."
         );
      case "censor-mode-feathering":
         return "How much to smoothen the edges of the effect area.";
      case "pixel-spacing":
         return "The distance by which to space out the pixels.";
      case "pixel-channel-colors":
         return "The number of channel colors to which to limit the pixels.";
      case "pixel-accurate-sampling":
         return "Whether to set the color of each pixel to the average color of all pixels it covers instead of to the color of just the centermost pixel it covers.";
      case "censor-mode-grayscale":
         return "Whether to desaturate the effect area.";
      case "pixel-resolution-aware":
         return "Whether to scale the strength according to the image size, where an image size of 1024 by 1024 would result in no scaling.";
      case "censor-mode-detection-size-aware":
         return "Whether to scale the strength according to the detection size, where a detection size of 1/8 of the image size would result in no scaling.";
      case "blur-resolution-aware":
         return "Whether to scale the strength according to the image size, where an image size of 1024 by 1024 would result in no scaling.";
      case "triangle-resolution-aware":
         return "Whether to scale the vertex count according to the image size, where an image size of 1024 by 1024 would result in no scaling.";
      case "triangle-threshold":
         return "The threshold details in the effect area must pass in order to be captured, where a higher threshold excludes smaller details.";
      case "triangle-accuracy":
         return "How accurately the triangles are traced along the captured details in the effect area.";
      case "triangle-blurring":
         return "How much to blur the effect area prior to triangulazing it.";
      case "triangle-fill-color-mode":
         return (
            "<span style='font-weight:bold;'>[Sample]:</span> Sample the fill color from the image." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Custom]:</span> Use a custom fill color."
         );
      case "triangle-stroke-color-mode":
         return (
            "<span style='font-weight:bold;'>[Sample]:</span> Sample the stroke color from the image." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Custom]:</span> Use a custom stroke color."
         );
      case "triangle-stroke-width":
         return "The stroke width prior to scaling according to the image size, where an image size of 1024 by 1024 would result in no scaling.";
      case "triangle-gradients":
         return "Whether to create color gradients between vertices.";
      case "triangle-gradient-stops":
         return "The number of times to sample a color along the path of a color gradient.";
      case "box-fill":
         return (
            "<span style='font-weight:bold;'>[On Enabled]:</span> Draw fill on detections of enabled content." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[On None]:</span> Don't draw fill."
         );
      case "box-border":
         return (
            "<span style='font-weight:bold;'>[On All]:</span> Draw a border on detections of any content." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[On Enabled]:</span> Draw a border on detections of enabled content."
         );
      case "glitch-multiple-panels-min-size":
         return "The minimum possible panel size relative to the effect area size.";
      case "glitch-multiple-panels-max-size":
         return "The maximum possible panel size relative to the effect area size.";
      case "glitch-multiple-panels-scatter":
         return "The maximum possible distance a panel can be shifted by, measured in the height or width of the effect area.";
      case "glitch-multiple-panels-split-chance":
         return "The chance for a panel to be split once into two smaller ones.";
      case "sticker-draw-mode":
         return (
            "<span style='font-weight:bold;'>[Per Body Part]:</span> Draw a sticker for all detections of each body part." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Per Detection]:</span> Draw a sticker for each detection."
         );
      case "sticker-draw-single-source":
         return "Whether to draw a single collection or group from which to draw all stickers.";
      case "sobel-inverted-color":
         return "Whether to invert the black and white of the effect area after sobelizing it.";
      case "splatter-recursions":
         return "The number of times to recursively generate sub splatters.";
      case "splatter-color-mode":
         return (
            "<span style='font-weight:bold;'>[Sample]:</span> Sample the splatter color from the image." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Custom]:</span> Draw a splatter color from a pool of custom colors."
         );
      case "splatter-color-pool":
         return "All the possible splatter colors from which to draw along with weights determining how likely each is to be drawn.";
      case "random-mode-random":
         return "Draws a random censor mode according to the weights.";
      case "random-mode-super-random":
         return "Draws a random censor mode according to the weights and also randomizes its configuration for maximum randomness.";
      case "mixed-entries":
         return (
            "<div>The censor modes and preset for each section that can be censored.</div>" +
            "<div class='tooltip-paragraph-break'></div>" +
            "<span style='color: #089a7c;font-weight:bold;'>TIP:</span> Use shift/ctrl + click to select multiple entries for editing at once."
         );
      case "clustering":
         return "Joins into one detections which overlap.";
      case "reverse-mode":
         return "Instead of censoring the detections, censors everything else in the image.";
      case "word-wall":
         return "Overlays all censor effects with a word wall.";
      case "word-wall-draw-mode-single":
         return "Draws a single entry from the word pool.";
      case "word-wall-draw-mode-multiple":
         return "Draws a random number of entries from the word pool in a random order.";
      case "word-wall-draw-mode-all":
         return "Draws all entries from the word pool in a random order.";
      case "word-wall-color-mode":
         return (
            "<span style='font-weight:bold;'>[Sample]:</span> Sample the color from the image." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Custom]:</span> Use a custom color."
         );
      case "oom":
         return (
            "Permanently blocks images after they've been viewed once." +
            "<div class='tooltip-paragraph-break'></div>This works by computing and comparing image hashes, which means that once an image is blocked, any other occurrence of it across the web will also be blocked from there on."
         );
      case "remote-control":
         return (
            "Allows you to remotely control other users extensions." +
            "<div class='tooltip-paragraph-break'></div>" +
            "<div><b>1.</b> Create a new remote control.</div>" +
            "<div><b>2.</b> Bind a cloud settings ID to your remote.</div>" +
            "<div><b>3.</b> Have the users to be remotely controlled subscribe to your remote from the settings page.</div>" +
            "<div><b>4.</b> Change the binded settings to whatever you please, when you please, all subscribers will be automatically updated!</div>"
         );
      case "remote-identifier":
         return "<span style='color: #089a7c;font-weight:bold;'>TIP:</span> Have the users to be remotely controlled paste this over at the settings page.";
      case "oom-list-detections":
         return "Lists all detected content on each blocked image.";
      case "copied-message":
         return (
            "<h3>Copied to clipboard</h3>" +
            "<div class='ui-tooltip-content'>" +
            "</div>" +
            "<div class='ui-tooltip-support'>" +
            "</div>"
         );
      case "cloud-config-data":
         return "<div id='settings-affected-configurations' class='ui-tooltip-content'>";
      case "patreon-cache":
         let user_req = browser.storage.sync.get(["user"]);
         user_req.then((res) => {
            const date1 = Date.parse(res.user.patreon_cache);
            const date2 = new Date();
            const diffTime = Math.abs(date2 - date1);
            const diffDays = 14 - Math.ceil(diffTime / (1000 * 60 * 60 * 24));
            let t = "<b style='color: var(--caution-button-color)'>today</b>";
            if (diffDays > 0) {
               t =
                  "in <b style='color: var(--caution-button-color)'>" +
                  diffDays +
                  "</b> days.";
            }
            $("#patreon-cache-date").html("Patreon rewards will expire " + t);
         });
         return (
            "<span style='color:var(--caution-button-color);font-weight:bold;'>Warning:</span> Your <span id='patreon-cache-date'></span>." +
            "<div class='tooltip-paragraph-break'></div>" +
            "<span>If you're still a Patreon subscriber, please refresh your account status through here, or if that doesn't work, rebind your account to Patreon</span"
         );
      case "remote-lock":
         return "<span style='color:var(--caution-button-color);font-weight:bold;'>Warning:</span> Removes your ability to cancel the remote control subscription, leaving it only to the remote owner to release you.";
      case "remote-error":
         return (
            "<h3>Remote Cloud Error</h3>" +
            "<div class='ui-tooltip-content'>" +
            "This can happen if your local data does not match with the cloud data.<br>" +
            "This can happen due to network errors or due to a hard reset of your local settings" +
            "</div>" +
            "<div>" +
            "<ul style='margin-left: -20px'>" +
            "<li>Missing Local Data:<br> The Extension has data of an ongoing subscription." +
            "<li>Missing Cloud Data:<br> The Cloud has data of an ongoing subscription." +
            "<li>Data Missmatch:<br> The Cloud has data of a different ongoing subscription than your extension." +
            "<li>No Remote Settings Deposited:<br> The Remote Instance has no settings attached<br>(this can be intentional)." +
            "</ul>" +
            "</div>"
         );
      case "timer-mode":
         return (
            "<span style='font-weight:bold;'>[Duration]:</span> Upon locking, set the timer to the duration specified." +
            "<div></div>" +
            "<span style='font-weight:bold;'>[Date]:</span> Upon locking, set the timer to the time remaining until the specified date."
         );
      case "overlay-unsupported":
         return "Mode not supported in video overlays.";
      case "password-copied-to-clipboard":
         return '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="18"><path d="M4 7V21H18V23H4C2.9 23 2 22.1 2 21V7H4M20 3C21.1 3 22 3.9 22 5V17C22 18.1 21.1 19 20 19H8C6.9 19 6 18.1 6 17V5C6 3.9 6.9 3 8 3H11.18C11.6 1.84 12.7 1 14 1C15.3 1 16.4 1.84 16.82 3H20M14 3C13.45 3 13 3.45 13 4C13 4.55 13.45 5 14 5C14.55 5 15 4.55 15 4C15 3.45 14.55 3 14 3M10 7V5H8V17H20V5H18V7H10Z" fill="currentColor" /></svg>';
   }
   return "";
}
