$('button.typeww').click(function(e){
	browser.storage.sync.get(['word_wall_configuration','lock_configuration']).then((res) => {
		if(res.lock_configuration.enabled) return;
		let value = $(this).hasClass('selected');
		if (value) {
			$('.word-wall-toggle').removeAttr('check');
			$(this).removeClass('selected');
		} else {
			$('.word-wall-toggle').attr('check', true);
			$(this).addClass('selected');
		}
		res.word_wall_configuration.enabled = !value;
        setMixedReverseRowSelected(res.word_wall_configuration.enabled);
		browser.storage.sync.set({
				word_wall_configuration: res.word_wall_configuration
			}).then(function(){
				updateOptionsContentScript();
			});
	});
});

$('io-toggle.word-wall-toggle').click(function(e){
	browser.storage.sync.get(['word_wall_configuration','lock_configuration']).then((res) => {
		if(res.lock_configuration.enabled) return; 
		let value = $(this).attr('check') ? true : false;
		if (value) {
			$('button.typeww').addClass('selected');
		} else {
			$('button.typeww').removeClass('selected');
		}
		res.word_wall_configuration.enabled = value;
        setMixedReverseRowSelected(res.word_wall_configuration.enabled);
		browser.storage.sync.set({
			word_wall_configuration: res.word_wall_configuration
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('#word_wall_word_pool').on('change',function(e) {
    e.stopImmediatePropagation();
    let conf = browser.storage.sync.get(['word_wall_configuration', 'lock_configuration']);
    conf.then((res) => {
        if(res.lock_configuration.enabled) return;
        
        res.word_wall_configuration.word_pool =  $(this).val().split('\n').filter(item => item.length !== 0);
        browser.storage.sync.set({
            word_wall_configuration: res.word_wall_configuration
        }).then(function(){
            updateOptionsContentScript();
        });
    });
});

// TODO: consider listening for focus
$('#word_wall_font').on('click', function(e){
    const dataList = $('#fonts-available');
    if (dataList.children().length > 0) return;

    const fontDetector = new FontDetector();
    let available = [];
    dataList.empty();
    for (let i = 0; i < fonts.length; i++) {
        if(fontDetector.detect(fonts[i])){
            available.push(fonts[i]);
            dataList.append($('<option>', { value: fonts[i] }));
        }
    }
});

$('#word_wall_font').on('change', function() {
    const fontDetector = new FontDetector();
    if(!fontDetector.detect($(this).val())){
        window.alert("The entered font is not available!");
    }
});

const fonts = [
    'Agency FB',
    'Aharoni',
    'Aldhabi',
    'Andalus',
    'Angsana New',
    'AngsanaUPC',
    'Aparajita',
    'Arabic Typesetting',
    'Arial',
    'Bahnschrift',
    'Batang',
    'BatangChe',
    'BIZ UDGothic, BIZ UDPGothic',
    'BIZ UDMincho, BIZ UDPMincho',
    'Book Antiqua',
    'Browallia New',
    'BrowalliaUPC',
    'Calibri',
    'Calisto MT',
    'Cambria',
    'Cambria Math',
    'Candara',
    'Cascadia Code',
    'Century Gothic',
    'Comic Sans MS',
    'Consolas',
    'Constantia',
    'Copperplate Gothic',
    'Corbel',
    'Cordia New',
    'CordiaUPC',
    'Courier New',
    'DaunPenh',
    'David',
    'DengXian',
    'DilleniaUPC',
    'DFKai-SB',
    'DokChampa',
    'Dotum',
    'DotumChe',
    'Ebrima',
    'Estrangelo Edessa',
    'EucrosiaUPC',
    'Euphemia',
    'FangSong',
    'Franklin Gothic',
    'FrankRuehl',
    'FreesiaUPC',
    'Gabriola',
    'Gadugi',
    'Gautami',
    'Georgia',
    'Gill Sans MT',
    'Gisha',
    'Gulim',
    'GulimChe',
    'Gungsuh',
    'GungsuhChe',
    'HoloLens MDL2 Assets',
    'Impact',
    'Ink Free',
    'IrisUPC',
    'Iskoola Pota',
    'JasmineUPC',
    'Javanese Text',
    'KaiTi (SimKai)',
    'Kalinga',
    'Kartika',
    'Khmer UI',
    'KodchiangUPC',
    'Kokila',
    'Lao UI',
    'Latha',
    'Leelawadee',
    'Leelawadee UI',
    'Levenim MT',
    'LilyUPC',
    'Lucida Console',
    'Lucida Handwriting',
    'Lucida Sans Unicode',
    'Malgun Gothic',
    'Mangal',
    'Marlett',
    'Meiryo, Meiryo UI',
    'Microsoft Himalaya',
    'Microsoft JhengHei',
    'Microsoft JhengHei UI',
    'Microsoft New Tai Lue',
    'Microsoft PhagsPa',
    'Microsoft Sans Serif',
    'Microsoft Tai Le',
    'Microsoft Uighur',
    'Microsoft YaHei',
    'Microsoft YaHei UI',
    'Microsoft Yi Baiti',
    'MingLiU, PMingLiU',
    'MingLiU-ExtB, PMingLiU-ExtB',
    'MingLiU_HKSCS',
    'MingLiU_HKSCS-ExtB',
    'Miriam',
    'Miriam Fixed',
    'Mongolian Baiti',
    'MoolBoran',
    'MS Gothic',
    'MS PGothic',
    'MS Mincho',
    'MS PMincho',
    'MS UI Gothic',
    'MV Boli',
    'Myanmar Text',
    'Narkisim',
    'Nirmala UI',
    'NSimSun',
    'Nyala',
    'OCR-A Extended',
    'Palatino Linotype',
    'Plantagenet Cherokee',
    'Raavi',
    'Rod',
    'Sakkal Majalla',
    'Sanskrit Text',
    'Segoe MDL2 Assets',
    'Segoe Print',
    'Segoe Script',
    'Segoe SD',
    'Segoe UI',
    'Segoe UI Emoji',
    'Segoe UI Historic',
    'Segoe UI Symbol',
    'Segoe UI Variable',
    'Segoe Fluent Icons',
    'Shonar Bangla',
    'Shruti',
    'SimHei',
    'Simplified Arabic',
    'SimSun',
    'SimSun-ExtB',
    'Sitka Banner',
    'Sitka Display',
    'Sitka Heading',
    'Sitka Small',
    'Sitka Subheading',
    'Sitka Text',
    'Sylfaen',
    'Symbol',
    'Tahoma',
    'Times New Roman',
    'Traditional Arabic',
    'Trebuchet MS',
    'Tw Cen MT',
    'Tunga',
    'UD Digi Kyokasho N-R',
    'UD Digi Kyokasho N-B',
    'UD Digi Kyokasho NK-R',
    'UD Digi Kyokasho NK-B',
    'UD Digi Kyokasho NP-R',
    'UD Digi Kyokasho NP-B',
    'Urdu Typesetting',
    'Utsaah',
    'Vani',
    'Verdana',
    'Vijaya',
    'Vrinda',
    'Webdings',
    'Wingdings',
    'Yu Gothic',
    'Yu Gothic UI',
    'Yu Mincho'
];