window.onload = function () {
   restoreTheme();

   $(".onoff").on("click", function (e) {
      e.stopImmediatePropagation();
      if ($(this).attr("disabled") === "disabled") {
         return;
      }
      document.getElementById("onoff-button").toggleAttribute("check");
      document.getElementById("onoff-toggle").toggleAttribute("check");
      $("#onoff").html($(this).attr("check") === "" ? "ON" : "OFF");
      activatePuryFi($(this).attr("check") === "" ? true : false);
   });

   document
      .getElementById("reverse_censoring")
      .addEventListener("click", function () {
         document
            .getElementById("reverse_censoring-io")
            .toggleAttribute("check");
         document
            .getElementById("reverse_censoring-button")
            .toggleAttribute("check");
         let sync = browser.storage.sync.get(["reverse_mode_configuration"]);
         sync.then((res) => {
            res.reverse_mode_configuration.enabled = document
               .getElementById("reverse_censoring-button")
               .hasAttribute("check")
               ? true
               : false;
            browser.storage.sync
               .set({
                  reverse_mode_configuration: res.reverse_mode_configuration,
               })
               .then(function () {
                  updateOptionsContentScript();
               });
         });
      });

   $(".type-button").on("click", function (e) {
      browser.storage.sync
         .set({
            censor_type: $(this).attr("id"), //'blur'
         })
         .then(function () {
            updateOptionsContentScript();
         });
      $(".type-button").removeClass("selected");
      $(this).addClass("selected");
   });

   $(".labelButton").on("click", function (event) {
      $(this).toggleClass("selected");
      let labels = browser.storage.sync.get("labels");
      labels.then((res) => {
         labellist = res.labels || [];
         if ($(this).hasClass("selected")) {
            if (labellist.indexOf(this.id) === -1) {
               labellist.push(this.id);
            }
         } else {
            if (labellist.indexOf(this.id) != -1) {
               labellist = removeItemAll(labellist, this.id);
            }
         }
         browser.storage.sync
            .set({
               labels: labellist,
            })
            .then(function () {
               updateOptionsContentScript();
            });
      });
   });

   $("#options").on("click", function () {
      browser.runtime.openOptionsPage();
      $("body").hide();
   });

   $("#toggle_labels").on("click", function (event) {
      $(".labelButton").toggleClass("selected");
      let labels = browser.storage.sync.get("labels");
      labels.then((res) => {
         labellist = res.labels || [];
         $(".labelButton").each(function () {
            if ($(this).hasClass("selected")) {
               if (labellist.indexOf(this.id) === -1) {
                  labellist.push(this.id);
               }
            } else {
               if (labellist.indexOf(this.id) != -1) {
                  labellist = removeItemAll(labellist, this.id);
               }
            }
         });
         browser.storage.sync
            .set({
               labels: labellist,
            })
            .then(function () {
               updateOptionsContentScript();
            });
      });
   });

   $("#settings-select").change(function () {
      let setting_name = $("#settings-select").find(":selected").val();
      loadSettings(setting_name);
   });
};

function removeItemAll(arr, value) {
   let i = 0;
   while (i < arr.length) {
      if (arr[i] === value) {
         arr.splice(i, 1);
      } else {
         ++i;
      }
   }
   return arr;
}

function restoreOptions() {
   restoreONOFF();
   restoreCensor_Type();
   restoreLabels();
   restoreAdvanced();
   restoreLockUnlock();
   //updateQuickSettings();
}

function restoreCensor_Type() {
   let censor_type = browser.storage.sync.get("censor_type");
   censor_type.then((res) => {
      document.getElementById("normal").classList.remove("selected");
      document.getElementById("box").classList.remove("selected");
      document.getElementById("black").classList.remove("selected");
      document.getElementById("pixel").classList.remove("selected");
      document.getElementById("blur").classList.remove("selected");
      document.getElementById("glitch").classList.remove("selected");
      document.getElementById("" + res.censor_type).classList.add("selected");
   });
}

function restoreLabels() {
   let labels = browser.storage.sync.get("labels");
   labels.then((res) => {
      $(".labelButton").each(function (i, obj) {
         if (res.labels.includes(obj.id)) {
            $(this).addClass("selected");
         } else {
            $(this).removeClass("selected");
         }
      });
   });
}

function restoreAdvanced() {
   let sync = browser.storage.sync.get(["user", "reverse_mode_configuration"]);
   sync.then((res) => {
      if (res.reverse_mode_configuration.enabled) {
         document
            .getElementById("reverse_censoring-button")
            .setAttribute("check", "true");
         document
            .getElementById("reverse_censoring-io")
            .setAttribute("check", "true");
      } else {
         document
            .getElementById("reverse_censoring-button")
            .removeAttribute("check");
         document
            .getElementById("reverse_censoring-io")
            .removeAttribute("check");
      }

      if (
         res.user &&
         res.user.permissions.permission_reverse_censoring <=
            res.user.patreon_tier
      ) {
         $("#reverse_mode").show();
      } else {
         $("#reverse_mode").hide();
      }
   });
}

document.addEventListener("DOMContentLoaded", restoreOptions);

let labels = browser.storage.sync.get("labels");
labels.then((res) => {
   if (res.labels == null) {
      let labels = browser.storage.sync.get("labels");
      labels.then((res) => {
         let labellist = [];
         $(".labelButton").each(function (i, obj) {
            labellist.push(obj.id);
            $(this).addClass("selected");
         });
         browser.storage.sync
            .set({
               labels: labellist,
            })
            .then(function () {
               updateOptionsContentScript();
            });
      });
   }
});

let censor_type = browser.storage.sync.get("censor_type");
censor_type.then((res) => {
   if (res.censor_type == null) {
      browser.storage.sync
         .set({
            censor_type: "black",
         })
         .then(function () {
            updateOptionsContentScript();
         });
   }
});

let icon_mode = browser.storage.sync.get("icon_configuration");
icon_mode.then((res) => {
   if (res.icon_configuration != null && !res.icon_configuration.save_mode) {
      $(".icon-public").addClass("icon-nude").removeClass("icon-public");
   }
});
